/* Copyright (c) 2009 
 * Licensed under GPL (http://www.opensource.org/licenses/gpl-2.0.php)
 * Use only for non-commercial usage.
 *
 * Version : 0.5
 *
 * Requires: jQuery 1.2+
 */
 
(function($)
{
  jQuery.fn.Rut = function(options)
  {
    var defaults = {
      digito_verificador: null,
      on_error: function(){},
      on_success: function(){},
      validation: true,
      format: true,
      format_on: 'change'
    };

    var opts = $.extend(defaults, options);

    this.each(function(){
    
      if(defaults.format)
      {
        jQuery(this).bind(defaults.format_on, function(){
          jQuery(this).val(jQuery.Rut.formatear(jQuery(this).val(),defaults.digito_verificador==null));
        });
      }
      if(defaults.validation)
      {
        if(defaults.digito_verificador == null)
        {
          jQuery(this).bind('blur', function(){
            var rut = jQuery(this).val();
            if(jQuery(this).val() != "" && !jQuery.Rut.validar(rut))
            {
                defaults.on_error();
            }
            else if(jQuery(this).val() != "")
            {
                defaults.on_success();
            }
          });
        }
        else
        {
          var id = jQuery(this).attr("id");
          jQuery(defaults.digito_verificador).bind('blur', function(){
            var rut = jQuery("#"+id).val()+"-"+jQuery(this).val();
            if(jQuery(this).val() != "" && !jQuery.Rut.validar(rut))
            {
                defaults.on_error();
            }
            else if(jQuery(this).val() != "")
            {
                defaults.on_success();
            }
          });
        }
      }
    });
  }
})(jQuery);

/**
  Funciones
*/


jQuery.Rut = {

  formatear:  function(Rut, digitoVerificador)
          {
          var sRut = new String(Rut);
          var sRutFormateado = '';
          sRut = jQuery.Rut.quitarFormato(sRut);
          if(digitoVerificador){
            var sDV = sRut.charAt(sRut.length-1);
            sRut = sRut.substring(0, sRut.length-1);
          }
          while( sRut.length > 3 )
          {
            sRutFormateado = "." + sRut.substr(sRut.length - 3) + sRutFormateado;
            sRut = sRut.substring(0, sRut.length - 3);
          }
          sRutFormateado = sRut + sRutFormateado;
          if(sRutFormateado != "" && digitoVerificador)
          {
            sRutFormateado += "-"+sDV;
          }
          else if(digitoVerificador)
          {
            sRutFormateado += sDV;
          }
          
          return sRutFormateado;
        },

  quitarFormato: function(rut)
        {
          var strRut = new String(rut);
          while( strRut.indexOf(".") != -1 )
          {
          strRut = strRut.replace(".","");
          }
          while( strRut.indexOf("-") != -1 )
          {
          strRut = strRut.replace("-","");
          }
          
          return strRut;
        },

  digitoValido: function(dv)
        { 
          if ( dv != '0' && dv != '1' && dv != '2' && dv != '3' && dv != '4' 
            && dv != '5' && dv != '6' && dv != '7' && dv != '8' && dv != '9' 
            && dv != 'k'  && dv != 'K')
          {   
            return false; 
          } 
          return true;
        },

  digitoCorrecto:   function(crut)
          { 
            largo = crut.length;
            if ( largo < 2 )  
            {   
              return false; 
            }
            if(largo > 2)
            {
              rut = crut.substring(0, largo - 1);
            }
            else
            {   
              rut = crut.charAt(0);
            }
            dv = crut.charAt(largo-1);
            jQuery.Rut.digitoValido(dv);  
          
            if(rut == null || dv == null)
            {
              return 0;
            }

            dvr = jQuery.Rut.getDigito(rut);

            if (dvr != dv.toLowerCase())  
            {   
              return false;
            }
            return true;
          },

  getDigito:    function(rut)
        {
          var dvr = '0';
          suma = 0;
          mul  = 2;
          for(iRUT=rut.length -1;iRUT >= 0;iRUT--) 
          { 
            suma = suma + rut.charAt(iRUT) * mul;    
            if (mul == 7)
            {
              mul = 2;
            }   
            else
            {         
              mul++;
            } 
          }
          res = suma % 11;  
          if (res==1)
          {
            return 'k';
          } 
          else if(res==0)
          {   
            return '0';
          } 
          else  
          {   
            return 11-res;
          }
        },

  validar:   function(textoRUT)
        {
          textoRUT = jQuery.Rut.quitarFormato(textoRUT);
          largoRUT = textoRUT.length;
        
          // rut muy corto
          if ( largoRUT < 2 )  
          {
            return false; 
          }
    
          // verifica que los numeros correspondan a los de rut
          for (iRUT=0; iRUT < largoRUT ; iRUT++ ) 
          {   
            // numero o letra que no corresponda a los del rut
            if(!jQuery.Rut.digitoValido(textoRUT.charAt(iRUT)))
            {     
              return false;
            }
          }
    
          var invertidoRUT = "";
          for(iRUT=(largoRUT-1),jRUT=0; iRUT>=0; iRUT--,jRUT++)
          {
            invertidoRUT = invertidoRUT + textoRUT.charAt(iRUT);
          }
          var dtextoRUT = "";
          dtextoRUT = dtextoRUT + invertidoRUT.charAt(0);
          dtextoRUT = dtextoRUT + '-';  
          cntRUT = 0;  
        
          for ( iRUT=1,jRUT=2; iRUT<largoRUT; iRUT++,jRUT++ ) 
          {
            if ( cntRUT == 3 )   
            {     
              dtextoRUT = dtextoRUT + '.';      
              jRUT++;      
              dtextoRUT = dtextoRUT + invertidoRUT.charAt(iRUT);      
              cntRUT = 1;    
            }
            else    
            {       
              dtextoRUT = dtextoRUT + invertidoRUT.charAt(iRUT);      
              cntRUT++;    
            } 
          } 
        
          invertidoRUT = ""; 
          for (iRUT=(dtextoRUT.length-1),jRUT=0; iRUT>=0; iRUT--,jRUT++)
          {   
            invertidoRUT = invertidoRUT + dtextoRUT.charAt(iRUT);
          }
    
          if (jQuery.Rut.digitoCorrecto(textoRUT))
          {   
            return true;
          }
          return false;
        }
};
